import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.Scanner;

import com.google.gson.Gson;

public class Main {

	public static void main(String[] args) {
		System.out.println("Entra cliente");
		Socket socket;
		Gson gson = new Gson();
		try {
			if(args.length>0) {
				socket = new Socket(args[0], 8080);
			}else {
				socket = new Socket("localhost", 8080);
			}
			
			Scanner es = new Scanner(System.in);
			BufferedReader bufferEntrada = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			PrintWriter bufferSalida = new PrintWriter(new OutputStreamWriter(socket.getOutputStream()),true);
			String entrada = gson.fromJson(bufferEntrada.readLine(), String.class);
			System.out.println(entrada);
			
			System.out.println("Introduce el numero de partida en el que quieres entrar");
			bufferSalida.println(es.nextLine());
			System.out.println(gson.fromJson(bufferEntrada.readLine(), String.class));
			String tipoJuego = gson.fromJson(bufferEntrada.readLine(), String.class);
			switch(tipoJuego) {
			case "3":
				partida3(bufferEntrada, bufferSalida, es);
				break;
			case "4":
				partida4(bufferEntrada, bufferSalida, es);
				break;
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	static void partida3(BufferedReader bufferEntrada, PrintWriter bufferSalida, Scanner es) throws IOException {
		Gson gson = new Gson();
		System.out.println(gson.fromJson(bufferEntrada.readLine(), String.class));
		System.out.println(gson.fromJson(bufferEntrada.readLine(), String.class));
		while(dibujarTablero(bufferEntrada)) {
			System.out.println("introduce la x de la nueva marca");
			bufferSalida.println(es.nextLine());
			System.out.println("introduce la y de la nueva marca");
			bufferSalida.println(es.nextLine());
		}
	}
	
	static void partida4(BufferedReader bufferEntrada, PrintWriter bufferSalida, Scanner es) throws IOException {
		Gson gson = new Gson();
		System.out.println(gson.fromJson(bufferEntrada.readLine(), String.class));
		System.out.println(gson.fromJson(bufferEntrada.readLine(), String.class));
		while(dibujarTablero(bufferEntrada)) {
			System.out.println("introduce la columna de la nueva ficha");
			bufferSalida.println(gson.fromJson(es.nextLine(), String.class));
		}
	}
	
	static boolean dibujarTablero(BufferedReader entrada) throws IOException {
		Gson gson = new Gson();
		String linea = gson.fromJson(entrada.readLine(), String.class);
		if(linea.contains("v")) {
			System.out.println("Has ganado!");
		}else if (linea.contains("f")){
			System.out.println("Has perdido...");
		}else {
			System.out.println(linea);
			return true;
		}
		return false;
	}
	
}
